VUZE CHANGELOG
-----------------

2009.04.09 | Vuze 4.2.0.2

BUGFIX: UI   | Fix wrap on category buttons [TuxPaper]
BUGFIX: UI   | Fix rare case when last sash position in My Torrents wasn't being obeyed [TuxPaper]
BUGFIX: UI   | Remove device toolbar when device feature not avail [TuxPaper]
BUGFIX: Core | Fix hang on startup with some UPnP devices [Parg]
BUGFIX: Plug | Force decode of HTTP headers to lowercase using ISO8859-1 charset to fix matching error in Turkish [Parg]


2009.03.23 | Vuze 4.2.0.0

FEATURE: Core | Devices [parg]
FEATURE: UIvz | UI for Devices panel, individual Device panel, Device chooser, and Device Profile Chooser [TuxPaper]
FEATURE: Plug | Transcoding [gudy,parg]

BUGFIX: Core  | Fix IP binding error when performing a NAT test under Vista [The 8472]
BUGFIX: UIvz  | Fix some notifications not getting pulled [TuxPaper]



2009.02.25 | Vuze 4.1.0.4
   
FEATURE: UI   | Donation Window [TuxPaper]
   


2009.02.05 | Vuze 4.1.0.2

FEATURE: UI   | Config option for max stalled seeding torrents (was hardcoded in 4100) [TuxPaper]

BUGFIX: Core  | Fix null-pointer-exception when initiasing old categorised shares [Parg]
BUGFIX: Core  | Remove accidental invocation of the get-networks Vuze RPC when running in classic UI [Parg]
BUGFIX: Core  | Remove null-pointer-exception in TCP connection manager [Parg]
BUGFIX: Core  | Fix subscription auto-download with sites where supplied referer caused error [Parg]
BUGFIX: UIvz  | Click area for Friend's "chat thought bubble" was wrong, preventing click to chat in some cases [TuxPaper]
BUGFIX: UIvz  | Fix share of vuze content (users could only share non-vuze content) [TuxPaper]
BUGFIX: UI    | Column Setup visual fixes for gtk [TuxPaper]
BUGFIX: UI    | Revert category buttons to working state [TuxPaper]
BUGFIX: UI    | Fixed memory leak in All-Peers view [Parg]
BUGFIX: UI    | Fixed resource disposal in config view causing some status bar icons to not draw [TuxPaper]

CHANGE: Core  | Remove various debug-spew [Parg]



2009.01.26 | Vuze 4.1.0.0

FEATURE: Core | New FP Ignore rule: Ignore 1st Priority after X hours of idle upload speed (default 24h) [TuxPaper] 
FEATURE: Core | Support for loading torrents when the HTTP response is an error (like 404, 500) but the data is still a torrent [TuxPaper] 
FEATURE: UIvz | Support multiple Content Networks [parg,tuxpaper]
FEATURE: UI   | Experimental neuronal speed algorithm [Gudy]
FEATURE: UI   | Added AS/ASN peer column [Parg]
FEATURE: UI   | Added properties view to buddies avatar widget [Parg]
FEATURE: UI   | Control+I in library to open torrent info (torrent details) page [TuxPaper]
FEATURE: Plug | Share categories with friends as subscriptions [Parg]
FEATURE: Plug | Support table column removal [Parg]
FEATURE: Plug | Added getComputerName method [Parg]
FEATURE: Plug | Cache connected friend details for faster reconnect on startup [Parg]

CHANGE: Core  | Pulled out Vuze related operations into ContentNetwork [Parg]
CHANGE: Core  | Go to CDP when torrent unauthorised if possible [Parg]
CHANGE: Core  | Added date field an modified case of response HTTP headers to improve behaviour of SSDP clients [Parg]
CHANGE: Core  | Limit # of stalled 'seeding' torrents to prevent cases where all completed torrents could start up [TuxPaper] 
CHANGE: Core  | Give stalled torrents a seeding rank handicap based on how long they've been stalled for [TuxPaper] 
CHANGE: UI    | (Memory) Images that are unused after 60 seconds are now disposed of [TuxPaper]
CHANGE: UI    | Fixed regression of Auto Open Tabs not opening seeding torrents (Config option now split) [TuxPaper]
CHANGE: UI    | Bring back classic-share menu for non-basic mode users [Parg]

BUGFIX: Core  | Setting files as do-not-download was deleting files [Parg]
BUGFIX: Core  | IPv6 compact tracker support [Parg]
BUGFIX: Core  | Fix possible deadlock in generic connection handling [Parg]
BUGFIX: Core  | Disable if-modified logic when editting RSS search templates to allow retrieval of results [Parg]
BUGFIX: Core  | Clear down TLS stuff to reduce memory usage when plugins unloaded [Parg]
BUGFIX: UI    | Fixed rare case where table rows would display blank [TuxPaper]
BUGFIX: UI    | Fixed 'close all details' in classic UI [Parg]
BUGFIX: UI    | Prevent constuction of mytorrents context menu from flipping download stats [Parg]
BUGFIX: UI    | Fix cursor transition in table cell [Parg]
BUGFIX: UI    | Fix incorrect handling of weak references for UI views that resulted in them never being released [Parg]
BUGFIX: Plug  | Various fixes to correctly release unloaded plugin resources [Parg]



2008.11.20 | Vuze 4.0.0.4

FEATURE: UIvz | Ability to change List modes in View menu [TuxPaper]
FEATURE: UI   | Added a 'mark all results unread' menu item [Parg]
FEATURE: UI   | Added specification of data save directory to config wizard [Parg]
FEATURE: Core | Added subscription support to customisations [Parg]
FEATURE: Core | Added an 'azplug' URL protocol to allow plugins to handle URLs [Parg]
FEATURE: Core | Allow subscriptions to handle azplug protocols thus allowing plugins to be the source of subscription content [Parg]
FEATURE: Core | Allow magnet links in search results [Parg]

CHANGE: UIvz  | Deleting via toolbar now lets you apply action to all selected entries [TuxPaper] 
CHANGE: UIvz  | Search bar shrinks a bit when there's not enough width to display all toolbar buttons [TuxPaper] 
CHANGE: UI    | Date Column auto-sizer now shows day of month (mm/dd) instead of year (yy/mm) when column is small [TuxPaper]
CHANGE: Core  | Only show feed errors after 3 consecutive fails to avoid distracting transient errors [Parg]
CHANGE: Core  | Add asset hash to subscriptions and auto-associate existing content on subscribe if avail [Parg]
CHANGE: Core  | Various performance improvements [Parg]
CHANGE: Core  | Modify DHT size calc algorithm to take account of firewalled contact [Parg]
CHANGE: Plug  | Assume buddies support chat [Parg]

BUGFIX: UIvz  | "Mark All Watched" now only affects completed content (which is also what Unwatched only shows) [TuxPaper]
BUGFIX: UIvz  | Fix Global Rating column not sorting properly [TuxPaper]
BUGFIX: UIvz  | (Mac) Fixed closing sidebar entries sometimes showing a blank area instead of selecting a new sidebar entry [TuxPaper]
BUGFIX: UIvz  | Fixed bug where "My Library" info bar displayed on Downloading sidebar entry [TuxPaper]
BUGFIX: UIvz  | Fix some notification entries losing their related avatar image [TuxPaper]
BUGFIX: UIvz  | Log View's "Show Config" button wasn't going to proper config section [TuxPaper]
BUGFIX: UIvz  | Fix default visible columns, order, and sort column for new installs for "Advanced" library Lists [TuxPaper]
BUGFIX: UI    | "Show Time" state on date columns now remembered accross sessions [TuxPaper]
BUGFIX: UI    | Fix "Pieces" column in Library view not updating unless you clicked it [TuxPaper]
BUGFIX: UI    | Info tab in Torrent Details now displays more columns that it couldn't before (like share ratio) [TuxPaper]
BUGFIX: UI    | Localize the date in the subscription view correctly [Parg]
BUGFIX: Core  | Synchonize access to file operations so that an close op can't be interleaved with file facade switching and bork disk channel operation [Parg]
BUGFIX: Core  | Filter out duplicate skew reports to get more accurate figures [Parg]
BUGFIX: Core  | Avoid NPE in chat when buddy unauthorised [Parg]
BUGFIX: Core  | Preserve argument case in magnet link operations [Parg]
BUGFIX: Core  | Fix mem leak when DHT router IP changed [Parg]
BUGFIX: Plug  | Use UTF-8 when decoding plugin descriptions [Parg]



2008.10.24 | Vuze 4.0.0.2

FEATURE: UIvz | Added column to detail the linkage between content and associated subscription, where present [Parg]
FEATURE: UIvz | Simple view menu
 
CHANGE: Core  | Remove restriction on uniqueness of subscriptions names [Parg]
CHANGE: Core  | Add popularity to subscription properties and size better [Parg]
CHANGE: Core  | Impose lower limits on download and upload when auto-speed running [Parg]
CHANGE: Core  | Reduce subscription publication concurrency [Parg]
CHANGE: Core  | Reduce acceptance of inaccurate DHT store operations [Parg] 
CHANGE: Core  | Auto-download content when marked as unread in an auto-download enabled subscription [Parg]
CHANGE: UIvz  | Image on left of search box now activates search when clicked [TuxPaper]
CHANGE: UIvz  | Toolbar's "Show Text" state now remembered across sessions [TuxPaper] 
CHANGE: UIvz  | Classic users upgrading via the installer will start up in My Library in "small" mode (classic My Torrents View).  Previously, only "Advanced UI" users got this. [TuxPaper]
CHANGE: UIvz  | If you hold the mouse down for a period of time on Up and Down toolbar items, it will move the selected items to the top/bottom (this was present in 4000, but now the tooltip says it) [TuxPaper]  
CHANGE: UIvz  | Added tooltip to subscription wizard to show more details on subscription [Parg]
CHANGE: UIvz  | Drop into edit mode after creating an RSS subscription [Parg]
CHANGE: UIvz  | Reduce size shown for downloads to 3 digits max for subscriptions and searches [Parg]
CHANGE: UIVz  | In Library view fix sort so 'new' entries do sort to top [Parg]
CHANGE: Plug  | Reduce derived tracker targets by raising swarm size limits [Parg]

BUGFIX: Core  | Fix auto-subscription of DHT located singleton subscriptions [Parg]
BUGFIX: Core  | Subscription to already cached, unsubscribed subscriptions wasn't working [Parg]
BUGFIX: Core  | Fix 100% CPU problem due to unsafe HashSet modification [Parg]
BUGFIX: Core  | Remove duplicate results from subscriptions [Parg]
BUGFIX: Core  | Report subscription creation errors to user [Parg]
BUGFIX: Core  | If a subscription was deleted which being processed it used to report errors [Parg]
BUGFIX: Core  | Set subscription popularity on selection [Parg]
BUGFIX: UIvz  | Fixed missing of all incomplete-specific and complete-specific torrent columns in My Library in "big" mode [TuxPaper]
BUGFIX: UIvz  | If you previously chose top bar to be visible, and you aren't in advanced user mode, there was no way to remove top bar.  Fixed by not showing top bar in non-advanced user mode [TuxPaper]
BUGFIX: UIvz  | Fixed sidebar sash disappearing when moving beyond minimum size [TuxPaper]
BUGFIX: UIvz  | Fixed "Close All Details" menu item always being disabled [TuxPaper] 
BUGFIX: UIvz  | Fixed extremely slow Library view when one column was animating [TuxPaper] 
BUGFIX: UI    | Table cells with cutoff text should show tooltip now [TuxPaper]
BUGFIX: UI    | Fixed copying cell's text to clipboard [TuxPaper] 
BUGFIX: UI    | Info tab in Torrent Details now displays some columns that it couldn't before [TuxPaper] 
BUGFIX: UI    | Clear log view widgets when not visible to reduce memory [Parg]
BUGFIX: UI    | Fix sub tabs in Torrent Details view not remembering their view after restoring from min. state [TuxPaper]


2008.10.15 | Vuze 4.0.0.0

FEATURE: Core | Async request processing for non-blocking tracker [Parg]
FEATURE: Core | Support HTTP redirects between http/https protocols in resource downloader [Parg]
FEATURE: Core | Add content to UPnP authentication dialogs [Parg]
FEATURE: Core | Support PList mods for app registration on OSX [Parg]
FEATURE: Core | Added http auth helper to support authenticated search templates/subscriptions [Parg]
FEATURE: Core | Fix built in RSS feed parser to handle Atom feeds [Parg]
FEATURE: Core | RSS based search templates [Parg]
FEATURE: Core | Light weight seeds to allow seeding of simple content such as subscriptions [Parg]
FEATURE: Core | Subscriptions [Parg]
FEATURE: Core | Added a 'prefer UDP connections' option [Parg]
FEATURE: Core | Config options for max queued outgoing connections [Parg]
FEATURE: Core | Support dht:// URL protocol [Parg]
FEATURE: Core | Advanced options for specifying TCP select timeouts [Parg]
FEATURE: UI   | Added "Column Setup" icon to the iconbar [amc1]
FEATURE: UI   | New console command - "plugin". Displays plugin information and can toggle startup status [amc1]
FEATURE: UI   | Console command "show" can now filter to list only torrents which are transferring [amc1]
FEATURE: UIvz | SideBar (F7 to Hide/Show) [TuxPaper]
FEATURE: UIvz | New ToolBar with hideable text [TuxPaper]
FEATURE: UIvz | Library now has Large and Small view modes.  Small view mode is classic My Torrents [TuxPaper]
FEATURE: Plug | Added option to remove originators IP address from stored values [Parg]

CHANGE: Core  | Improve app startup time [Parg]
CHANGE: Core  | Make full name and namespace URI available to simple XML parser users [Parg]
CHANGE: Core  | Improved handling of mixed IPv4 and IPv6 bindings [The 8472]
CHANGE: Core  | New option to refresh UPnP mappings when we become firewalled [amc1]
CHANGE: UI    | Improve performance with single data source dispatch aggregator [Parg]
CHANGE: UI    | Debug messages are no longer displayed by default when running the console UI [amc1]
CHANGE: UI    | The comment icon column now displays a blank icon if there is no comment (rather than no icon) [amc1]
CHANGE: UI    | Delete priority is now properly reflected in the Priority column [The 8472]
CHANGE: UIvz  | Faster Startup [parg,TuxPaper]
CHANGE: UIvz  | Reduced UI memory footprint [TuxPaper]
CHANGE: UIvz  | Friends moved to the bottom of the sidebar [Khai]
CHANGE: UIvz  | All table views (Library, Notifications) now use native table widget [TuxPaper]
CHANGE: Plug  | Essential plugins are now automatically re-enabled if previously disabled by user [amc1]
                 - the "Start / Stop Rules" plugin was disabled by users in the past, this was causing torrents to be stuck in "waiting" state
CHANGE: Plug  | New command line option - "azureus.safemode", to disable lots of functionality when debugging problems [amc1]                 
CHANGE: Plug  | Client ID plugin is removed [amc1]
CHANGE: Plug  | New command line option - "azureus.loadplugins", to skip plugins being loaded at startup [amc1]
CHANGE: Plug  | Accept store operations from furher away contacts to decrease store fails [Parg]
CHANGE: Plug  | Evict contacts sooner from DHT router to improve liveness [Parg]
CHANGE: Plug  | Delay DHT task init to save memory [Parg]
CHANGE: Plug  | Finer-mesh for DHT network position derived tracking [Parg]
CHANGE: Plug  | De-prioritise DHT tracker put ops [Parg]

BUGFIX: Core  | Fixed problem on Vista where "Failed to establish listen on port UDP:xxxxx" errors may be reported [parg]
BUGFIX: Core  | Treat any address binds as no bind IP when rewriting URLs [Parg]
BUGFIX: Core  | Added third party impressions urls for torrent ads [JR]
BUGFIX: Core  | Fix timer cancellation behaviour [Parg]
BUGFIX: Core  | Fixed DND deleting files in single-file torrents [The 8472]
BUGFIX: Core  | Fixed occasional deadlocks on startup under linux [The 8472]
BUGFIX: Core  | Fixed rare situation where user was prompted for authentication to connect to trackers which didn't need it [amc1]
BUGFIX: Core  | Made the load and unload buttons on the plugin page behave properly [amc1]
BUGFIX: Core  | Fixed problem where queueing rules do not enter "seeding-only" mode when there are queued downloads [amc1]
BUGFIX: Plug  | DHT storage manager key removal fix [Parg]
BUGFIX: Plug  | Various fixes to avoid DHT running out of control under extreme diversifications
BUGFIX: Plug  | Fix magnet download timeouts [Parg]
BUGFIX; Plug  | Fix DHT operation timeout bug introduced when moving to async exec [Parg]
BUGFIX: Plug  | Limit buddy reconnect to avoid thrashing [Parg]



2008.07.01 | Vuze 3.1.1.0

FEATURE: Core | Added Auto Starting rule to seed large swarms first; useful when many overseeded torrents are in the queue or the upload capacity is far above average [The 8472]
FEATURE: UIv3 | Friend Chat (double click on friend icon to chat) [Gudy]
FEATURE: UIv3 | Friends Online Status
FEATURE: UIv3 | Ability to share content from your computer by dragging it to a Friend [Gudy]

CHANGE: Core  | Built-in plugins can now be disabled - it didn't work properly in earlier versions [amc1]
CHANGE: UI    | Create Vivaldi views for each DHT in use [Groundy]
CHANGE: UI    | Added support for rotation in Vivaldi view [Groundy]
CHANGE: UI    | Peers view hostname column now sorts host names by the most significant part first [The 8472] 
CHANGE: UIv3  | Finished fixes for the new styled dialog which are now default in Vuze/Vuze Advanced [knguyen]
CHANGE: UIv3  | Added friend icon next to activity entry [TuxPaper]
CHANGE: UIv3  | New plugin bar look (removed arrows, added selectable list all plugin bar views) [TuxPaper]

BUGFIX: Core  | Fixed bug which stopped downloads being stored in the chosen directory [amc1]
BUGFIX: Core  | Fixed bug which prevented torrent files from being moved properly [amc1]
BUGFIX: Core  | Reopening torrents does not delete files when setting some of the already existing files to DND anymore [The 8472]
BUGFIX: Core  | Fixed bug which prevented UPnP mappings from being successful when a SOCKS proxy was used [amc1]
BUGFIX: UI    | Fixed bug where delete icon on toolbar was not present on OSX [TuxPaper]
BUGFIX: UI    | Blank cells are now properly put at the bottom when sorting a table column [amc1]
BUGFIX: UIv3  | Fixed bottom of list views not repainting properly [TuxPaper]
BUGFIX: UIv3  | Remove type headers when switching to date sorting [TuxPaper]



2008.06.16 | Vuze 3.1.0.0

FEATURE: UI   | Protocol overhead is now shown in the speed graph [The 8472]
FEATURE: UI   | Downloads can now be moved and renamed while running - torrent will be auto-paused [amc1]
FEATURE: UI   | New "rename" action which renames torrent file, save file and displayed name at same time [amc1]
FEATURE: UI   | Plugin log views now support autoscrolling, pausing and regex filtering [The 8472]
FEATURE: UI   | Plugin menu items which in the right-click menu now appear in the "Torrent" menu also [amc1] 
FEATURE: UIv3 | Friends (sharing, bandwidth boost)
FEATURE: UIv3 | Greatly Improved Search
FEATURE: UIv3 | Experimental option to use Mozilla/Firefox as browser widget on any platform (XulRunner or Firefox 3 must be installed) [The 8472]
FEATURE: Plug | Added support for plugins to easily use an external configuration file for settings [amc1]
FEATURE: Plug | Plugins can now have full control over on-complete and on-removal file moving [amc1]
FEATURE: Plug | Added resource downloader to provide way to download files from Sourceforge [amc1]
FEATURE: Plug | Added API methods to generically pop up the message box to a user [amc1]
FEATURE: Plug | Added API methods to listen to download-complete events [amc1]
FEATURE: Plug | Added various convenience methods for using log views and config models [amc1]
FEATURE: Plug | Added API to allow native UI objects to be added to config views [amc1]
FEATURE: Plug | Added some more methods for plugins to control some transport mechanisms [amc1]
FEATURE: Plug | Added ability to add menus to status entry objects [amc1]
FEATURE: Plug | Plugins can now open files using default application handlers [amc1]

CHANGE: Core  | added "upload_only" flag to AZMP/LTEP handshakes, disconnect any uploading_only peers we don't need / that don't need us when disconnect seeds when seeding is set [The 8472]
CHANGE: Core  | Further startup speed improvements [The 8472, amc1, Parg]
CHANGE: Core  | Speedup of various file batch operations (priority changes) [amc1, The 8472]
CHANGE: Core  | Added option to allow the removal of files linked outside the save directory when removing data [amc1]
CHANGE: UI    | Column menu option to disable fast renaming in files view, changed fast rename to behave more like the windows explorer [The 8472]
CHANGE: UI    | In console UI, shrunk help text down to be more concise [amc1]
CHANGE: UIv3  | Removed Vuze Header (the top plugin bar is still there but you have to turn it on)

BUGFIX: Core  | Made change so that plugins could not inadvertently turn off Azureus extension protocol [amc1]
BUGFIX: Core  | The UDP tracker client option has been nonfunctional for quite a while now -> fixed [The 8472]
BUGFIX: Core  | Fixed various file-priority-change related bugs that resulted in error states [The 8472]



2008.04.10 | Azureus Vuze 3.0.5.2

FEATURE: UIv3 | Ability to rate directly from rating reminder activity entry [TuxPaper] 
FEATURE: UIv3 | Added progress spinner animation for the LightBox [knguyen]

CHANGE: Core  | Don't auto-UDP probe on initial announce if tracker not known to support UDP - hit on second and remember outcome [Parg]
CHANGE: Core  | Improve startup times by taking various torrent-load operations off main thread [Parg]
CHANGE: Core  | Add reason-messages for update check failures [Parg]
CHANGE: Core  | Use derived password to protect private key to allow us to persist password [Parg]
CHANGE: Core  | Get plugin update URL from version server to support potential future switch [Parg]
CHANGE: UI    | Run explicit tracker scrapes off UI thread to prevent blocking [Parg]
CHANGE: UI    | Allow UI initialisation to proceed before plugin init complete [Parg]
CHANGE: UIv3  | Always start on "Dashboard" tab (unless Advanced UI chosen), instead of sometimes starting on "On Vuze" tab [TuxPaper]
CHANGE: Plug  | Ensure that DHT republish events are scheduled using absolute time so recover correctly from computer suspend [Parg]

BUGFIX: Core  | Handle some badly formed torrents more gracefully (corrupt announce-lists) [Parg]
BUGFIX: Core  | Handle multiple SSL certs from same URL [Parg]
BUGFIX: Core  | URLDecode torrent filenames [Parg]
BUGFIX: Core  | Fix non-crypto fallback outgoing connections [Parg]
BUGFIX: Core  | Better (esp for Vista) detection of and setting of Azureus' .torrent file association [TuxPaper]
BUGFIX: UI    | Fix broken per-torrent upload speed setting via options tab [Parg]
BUGFIX: UI    | Fix alternating bg color not updating after changing in config [TuxPaper]
BUGFIX: UIv3  | Fix resource leaks related to light box (login window) [knguyen]



2008.03.05 | Azureus Vuze 3.0.5.0

FEATURE: Core | Added µTorrent PEX support [amc1]
FEATURE: Core | Azureus probes trackers for UDP-capabilities on first scrape/announce now and uses udp instead of http where available [The 8472]
FEATURE: Core | Added option to enforce IP bindings even when the specified interfaces are not available (useful when Azureus should not use certain network interfaces) [The 8472] 
FEATURE: Core | Intervene with http seeds if progressive stall imminent [Parg]
FEATURE: Core | Message user on startup if they have installed Azureus to read-only location [Parg]
FEATURE: Core | Added dnd status to XML stats [Parg]
FEATURE: UI   | Added option for "Open Containing Folder" menu action - which may integrate better with non-standard file browsers [amc1]
FEATURE: UI   | Added option for "Show Torrent Menu" -- Users can now decide to see the Torrent menu in the menubar or not [knguyen]
FEATURE: UI   | Fast Renaming (not moving) in the Files tab (click on name column) and Open Torrent dialog (click on dest. name column) [The 8472]
FEATURE: UI   | Completed downloaders column [The 8472]
FEATURE: UI   | Added start/stop to category menu [Parg]
FEATURE: UI   | Added per-category speed limits [Parg]
FEATURE: UI   | Added per-category option setting [Parg]
FEATURE: UI   | Added multiple-torrent options setting to MyTorrents view [Parg]
FEATURE: UIv3 | New menu configuration for Vuze and Vuze Advanced UI's [knguyen]
FEATURE: UIv3 | Activity Tab [TuxPaper]
FEATURE: UIv3 | Vuze Login from client [knguyen]
FEATURE: Plug | Added Network Status plugin to perform some basic network tests [Parg]
FEATURE: Plug | Allow plugins to specify their minimum JDK requirements [Parg]

CHANGE: Core  | Further memory footprint reductions; for additional tweaks see http://www.azureuswiki.com/index.php/Reduce_memory_usage [The 8472]
CHANGE: Core  | Reimplemented LT extension protocol code [amc1]
CHANGE: Core  | DND/Compact (aka Delete) priority now deletes all files that do not share pieces with normal/high priority files [The 8472]
CHANGE: Core  | Queuing rules now don't start any further torrents if the global up/download speed limits are reached [The 8472]
                 - makes "don't count torrent ..." minimum speed rules more useful to dynamically regulate the queue lengths
                 - recovers faster from chain reactions in case of connection loss
CHANGE: Core  | Made the crypto handshake a bit less predictable [The 8472]
CHANGE: Core  | Added support for IPv6 compact announces (client) and udp-multiscrapes (client+server) [The 8472]
CHANGE: Core  | Take note of more peer-source selections [Parg]
CHANGE: Plug  | Added support for plugins which implement mainline DHT [amc1]

BUGFIX: Core  | Request limiting/Priorities no longer pinch off LAN peers if seperate LAN speeds are enabled [The 8472]                 
BUGFIX: Core  | Increase time Azureus holds open listen socket on close to reduce dual-start window [Parg]
BUGFIX: Core  | Allow ~ character in tracker addresses to support I2P [Parg]
BUGFIX: Core  | Determine app name correctly on OSX so that restart works for renamed apps [Parg]
BUGFIX: UI    | Shells no longer use the low-res frog icon, the normal main window icon is now used instead [amc1]
BUGFIX: UI    | Limiting comments in General View to 5k characters under WinXP to avoid crashes due to faulty comctl32.dll [The 8472]
BUGFIX: UI    | Setting speed parameters manually now disables autospeed [The 8472]
BUGFIX: Plug  | Encode spaces correctly in get-right web seed urls [Parg]




2007.12.21 | Azureus Vuze 3.0.4.2

FEATURE: UI   | Added "Check Files Exist" menu option [amc1]
FEATURE: Plug | Perform low resource usage tracking of online torrents for swarm cross-population purposes [Parg]

CHANGE: Core  | Added option to disable download speed focus [The 8472]
CHANGE: Core  | Reduced memory usage for many-torrent instances [The 8472]
CHANGE: UI    | Multiple selected torrent export now works [amc1]

BUGFIX: Core  | Fixed IP filters not working when ALLOW instead of DENY was used [Parg]
BUGFIX: Core  | Improve rebuffering behaviour when real-time pieces are too slow for any peers to get in time [Parg]
BUGFIX: Core  | Ensure minimum buffer requirements are factored into ETA calculation [Parg]
BUGFIX: UI    | Eliminated various memory leaks [The 8472]



2007.12.06 | Azureus Vuze 3.0.4.0

FEATURE: Core | Reconnect to peers after unexpected disconnect / recover stats of recently disconnected peers [Parg,The 8472]
FEATURE: Core | Global download speed limit can also limit the number of outgoing requests, this should improve TCP performance [The 8472]
                 -does not work with auto-speed since an explicit download speed-limit must be set
                 -downloads from as few peers as possible when the global limit is reached 
                 -prioritizes downloads which are on the head of the queue
FEATURE: Core | IP binding now provides primitive round-robin load balancing for users with multiple internet connections; accepts interface names and IPv6 binding (if supported on the platform) [The 8472]
FEATURE: Core | Embed ChangeLog.txt in release jar [Nolar]
FEATURE: UI   | Column menu option to automatically put contents of cell into the tooltip [amc1] 
FEATURE: UI   | Piece distribution view is now also available as a peer subview [The 8472]
FEATURE: UI   | Added 'time remaining' column to peers view [Parg]
FEATURE: UI   | Added option to suppress file download dialog [knguyen]
FEATURE: UI   | Various progress reports have been unified; main status bar can display progress for certain processes now [knguyen]
FEATURE: Plug | Plugins can now change the color of rows [amc1]
FEATURE: Plug | Plugins can add configuration colour parameters [amc1]

CHANGE: Core  | Attempt to re-open a file when access fails to try and recover from a transient error [Parg]
CHANGE: Core  | Auto speed default is now the new 'beta' (v2) algorithm [ranul]
CHANGE: Core  | Revised piece picking code to deal better with some edge cases and snubbed peers [The 8472]
CHANGE: Core  | Share Ratio/min Seeds ignore rule now applies even when no tracker scrape is available [The 8472]
CHANGE: UI    | Added private torrent indicator to the general tab [The 8472]
CHANGE: UI    | Logging Consoles now have regex-based filters [The 8472]
CHANGE: UI    | Tweaked table views to use a bit less memory and run better when items are being quickly removed/added [TuxPaper]

BUGFIX: UI    | Don't hang UI redraw if file access is slow [Parg]
BUGFIX: UI    | Fixed inconsistencies in the Torrent Open Dialog related to renaming and retargeting files and directories [The 8472]  



2007.10.04 | Azureus 3.0.3.4

FEATURE: UI   | Added "All Peers" view [amc1]

CHANGE: Core  | Added workarounds for some buggy UPnP router implementations [parg]
CHANGE: UI    | NAT status bar indicator and health icons now ignore UDP and LAN-local connections [The 8472]

BUGFIX: Core  | Fixed bug where a torrent's save location is "forgotten" when a recheck is done in some circumstances [amc1]
BUGFIX: UI    | times > 365 days (such as the uptime) are now displayed properly [The 8472]



2007.09.21 | Azureus 3.0.3.2

BUGFIX: Core  | Fixed MacOSX playback bug [TuxPaper]
BUGFIX: Core  | Fixed update restart bug [Parg]



2007.09.20 | Azureus 3.0.3.0

FEATURE: Core | Added experimental support for LibTorrent extension protocol handshake [amc1]
FEATURE: Core | Providing some experimental options for possible workarounds for a particular traffic shaping method
                 See http://www.azureuswiki.com/index.php/Avoid_traffic_shaping#Level_5 for further details 
FEATURE: UI   | Added available disk space indicators to the torrent open dialog (requires Java 1.6) [The 8472]
FEATURE: UI   | Added "handshake reserved bytes" column in peer view [amc1]
FEATURE: UI   | Added "Open Transfer Bar on start" and "Remember Transfer Bar" location options [amc1]
FEATURE: UI   | Added http-seed config to torrent creation wizard [Parg]
FEATURE: UIv3 | Embedded Media Player [TuxPaper] 

CHANGE: Core  | Speedup hash-checking by ~30% / less CPU usage [The 8472]
CHANGE: Core  | More improvements to client identification code [amc1]
CHANGE: UI    | Provide both "per-torrent" and "across-torrents" speed menu options [amc1]
CHANGE: UI    | Speed improvements for menu generation and changing file priority in "Files" view [amc1]
CHANGE: UI    | Allow minibars to stick to any screen border in multi monitor setups [The 8472]
CHANGE: Plug  | Plugins can now dynamically register language resource bundles [amc1]

BUGFIX: Core  | Fixed bug when trying to add torrents with semi-colon characters in filename [amc1]
BUGFIX: Core  | LAN peer detection for explicit IP addresses was broken [Parg]



2007.08.29 | Azureus 3.0.2.2

CHANGE: UI    | Improved usability of speed scale widget. [TuxPaper]
CHANGE: UI    | Restored reposition functionality of torrent context menus [TuxPaper]

BUGFIX: Core  | *nix: Allowing multi-instance now works again [TuxPaper]
BUGFIX: Core  | IPv6 DHT v4 pollution fix [Parg]
BUGFIX: UI    | MacOSX: Fixed not remembering user turned off Maximized state [TuxPaper]
BUGFIX: UI    | MacOSX: Fixed Drag and Drop for moving torrents in My Torrents view [TuxPaper]
BUGFIX: UI    | A few config pages had their labels missing [TuxPaper]



2007.08.16 | Azureus 3.0.2.0

FEATURE: Core | Act on suspend/resume events on Windows [Parg]
FEATURE: Core | Added new AZ message to inform of bad pieces [Parg]
FEATURE: Core | Added new stacked HAVE message to reduce peer-peer overhead [Parg]
FEATURE: Core | IPv6 support - dht, version server, tracker and improved transport [Parg]
FEATURE: UI   | New "Torrent" menu in the menu bar [amc1]
FEATURE: UI   | New "Piece Distribution" subview in the pieces tab [The 8472]
FEATURE: UI   | Auto-speed ping views in Tools->Statistics->Transfers when Auto Speed is enabled [Parg]
FEATURE: UI   | "Clear Resume Data" menu option added [amc1]
FEATURE: UI   | "Clear remembered save paths" option added (for the Open Torrent dialog) [amc1]

CHANGE: Core  | Optimise memory usage for single-file downloads [Parg]
CHANGE: Core  | Optimise memory usage for queued torrents (no need to keep resume data in memory) [Parg]
CHANGE: Core  | Much better peer ID identification code added, many more clients now correctly identified [amc1]
CHANGE: Core  | Changes made to identify some "fake" clients (or other clients which identify themselves in a problematic way) [amc1]
CHANGE: Core  | Biased optimistic disconnect slightly against leechy peers [The 8472]
CHANGE: Core  | Core changes in some places to allow "Default save path" to be used without requiring "Use default data dir" to be enabled [hasturkun]
CHANGE: Core  | Reduce CPU usage when many (queued) torrents are present and in the the pieces view [The 8472]
CHANGE: Core  | *nix: New startup script to detect Gecko/XULRunner and to allow better restarting [TuxPaper]
CHANGE: UI    | UL/DL speed selection on right click of status bar changed from menu to scale widget. [TuxPaper]
                Usage: (1) MouseDown+Drag+MouseUp  (2) Click+Move+Click  (3) Click+type number+Enter
CHANGE: UI    | Open Torrent Window now asks to create directories if they don't exist yet, instead of evilly auto-creating them when you click the Browse button [The 8472] 
CHANGE: UI    | Added download status, distributed copies and completed piece count to the General torrent view [amc1, The 8472]
CHANGE: UI    | User Comment field more useful in General torrent view - easy edit link, hyperlink formatting, auto-resizing [amc1]
CHANGE: UI    | "Show Transfer Bar" menu option is now a checkbox menu item - so you can now hide the transfer bar using the menu item [amc1]
CHANGE: Plug  | Added setVisible method for plugin menu items [amc1]
             
BUGFIX: Core  | Fixed bug where renaming a download for a single file torrent would sometimes cause data to get out of sync and cause file errors [amc1]
BUGFIX: Core  | Allow pipelined http seed requests to switch torrents [Parg]
BUGFIX: Core  | Bootstrap DHT better when no contacts [Parg]
BUGFIX: Core  | Fixed bug where renaming a download in some conditions would generate "Target is sub-directory" errors [amc1]                
BUGFIX: UI    | Fixed swarm view rendering bug where some incomplete peers were shown as full circles [The 8472]
BUGFIX: Plug  | Fixed bug where previously removed child menu items would still be present when generating some menus [amc1]



2007.06.20 | Azureus 3.0.1.6

FEATURE: Core | IP Filter Autoloading. Supports DAT (eMule), P2P (PeerGardian, splist), and P2B v1,2,3 (Peer Gardian 2) formats. [TuxPaper]
FEATURE: UI   | Option to display divider lines every 60 updates on the Statistics view [amc1]
FEATURE: Plug | Added helper class to make listening to download events across all downloads easier [amc1]
FEATURE: Core | Azureus AutoSpeed v2 Beta [ranul]

BUGFIX: Core | Plugin installation/updates using Vista [parg,tuxpaper]



2007.05.24 | Azureus 3.0.1.4

FEATURE: Core | Byte-level download control for Downloads [Parg] 
FEATURE: Core | Speed tester wizard [ranul,Parg]
FEATURE: UI   | Added "Transfers Bar" (similar to the "Download Bar") [amc1]
FEATURE: UI   | Correctly identifies FoxTorrent and Blizzard Downloader peers [amc1]
FEATURE: UI   | Determines version information for Bits On Wheels and Opera peers [amc1]
FEATURE: UI   | Vivaldi view can use mouse wheel too zoom now (requires clicking on the view first) [TuxPaper]
FEATURE: UI   | Date Completed column [TuxPaper]
FEATURE: UI   | (Beta) Various Auto Speed algorithms [ranul]
FEATURE: UI   | Auto-open MyShares if any shares [Parg]

CHANGE: Core  | Handle 503s better with webseeds [Jochen Seifarth,Parg]
CHANGE: Core  | Disable HTTP authentication dialog for webseeds [Parg]
CHANGE: Core  | Reduce DHT registration counts for queued torrents [Parg]
CHANGE: UI    | Running Azureus while azureus is already running now brings Azureus to front [TuxPaper]
CHANGE: UI    | OSX: Make minimize to status bar icon hide the main window instead of putting it in the doc [TuxPaper]

BUGFIX: Core  | Updater now works on Vista with security challenged users [TuxPaper] 
BUGFIX: Core  | Fixup "Get Right" webseed handling as per the spec [Jochen Seifarth]
BUGFIX: Core  | Fixed bug which sometimes prevented corrupted torrents being removed properly [amc1]
BUGFIX: Core  | Fix rare case where app dir on win32 could report wrong azureus dir on multi-az computers [TuxPaper]
BUGFIX: Core  | Prevent upnp dispatcher queue from growing too large [Parg]
BUGFIX: Core  | Limit UPnP write-request exec threads [Parg]
BUGFIX: UI    | Fixed force starting a torrent via the Open Torrent Window options. [TuxPaper]



2007.04.12 | Azureus 3.0.1.2

FEATURE: Core | Auto-speed: added control for forced-max network speed [Parg]

BUGFIX: Core  | 100% CPU problem in network code under some conditions [Parg]



2007.04.05 | Azureus 3.0.1.0

FEATURE: Core | Option to clear stored tracker list used for creating torrents [amc1]
FEATURE: UI   | Option to add full UPnP debug information to the log view [amc1]

BUGFIX:  UI   | Fixed issue where excessive file checks were being done when generating the torrent context menu [amc1]


2007.03.15 | Azureus 3.0.0.8

FEATURE: Core | Alerts can now be shown in individual message popup boxes [amc1]
FEATURE: Core | Alerts can now be suppressed and shown on demand [amc1]
FEATURE: Core | Per-peer upload/download speed limits [Parg]
FEATURE: Core | Per-category upload/download speed limits [Parg]
FEATURE: Core | Per-torrent super-seeding via MyTorrents context menu [Parg]
FEATURE: UI   | Option to auto-download and install updates [TuxPaper]
FEATURE: UI   | Overall piece map for Piece View [TuxPaper]
FEATURE: UI   | New "Peer ID" columns in the Peers View [amc1]
FEATURE: Plug | Plugins can now add their own status indicators on the status bar [amc1]
FEATURE: Plug | Plugins can now add menu items to the system tray, download bars, menu bar [amc1]
FEATURE: Plug | Plugins can now remove menu items that are created (allows for dynamic menus) [amc1]
FEATURE: Plug | Added extra methods on DownloadManager making it easier to listen to download events [amc1]

CHANGE: Core  | Include msvcr71.dll in Windows installation bundles, for compatibility with Java6 [Nolar]
CHANGE: Plug  | Added full set of config parameter methods for completeness [amc1]

BUGFIX: Plug  | UPnP plugin now correctly attempts to remove existing mappings if they are in the way of new mappings [amc1]
BUGFIX: Core  | Fix Re-adding a torrent causing "1-" or "-1" directories or files [TuxPaper]
BUGFIX: Core  | Fixed bug where files were sometimes moved into a subdirectory, where the directory name was only one character long [amc1]
BUGFIX: Plug  | Fixed bug where some plugin menu items didn't appear under certain conditions [amc1]


2007.01.22 | Azureus 2.5.0.4 / 3.0.0.6

FEATURE: Core | New users default save directory is now located in their "My Documents" directory, under "Azureus Downloads" [TuxPaper]
FEATURE: Core | Show alerts raised during closedown on next start as these often don't get displayed due to UI shutdown [Parg]
FEATURE: Core | Allow plugin installs to place jars into the plugin-shared "shared/lib" directory [Parg]
FEATURE: Plug | Unsafe config read/writing [parg]
FEATURE: Plug | Plugins can now open and close download bars [amc1]

CHANGE: Core  | Added scrape delay for stopped/errored torrents, and torrents with high share ratios [TuxPaper]
CHANGE: Core  | Allow only one active scrape for each tracker [TuxPaper]
CHANGE: Core  | Release piece-map when not required [Parg]
CHANGE: Core  | ASN lookup via DNS queries only [Parg]
CHANGE: Core  | Full recheck of torrent when part of torrent fails hash check on completion [TuxPaper]
CHANGE: Core  | Take note of banned IPs when we have IP filter turned off - these are independent [Parg]
CHANGE: Core  | Disable download peer caching for private torrents [Parg]
CHANGE: Core  | Disconnect currently connected peers on tracker URL change for private torrents [Parg]
CHANGE: Core  | Remove unused download/upload specific stats from version-check message [Parg]
CHANGE: Core  | Include IP override in NAT check message for NAT check server to use [Parg]
CHANGE: Plug  | Timeout UPnP port releases during closedown to prevent Azureus hanging [Parg]

BUGFIX: Core  | Fix choke/unchoke cycle bug for lan local peers [Nolar]
BUGFIX: Core  | Fix auto moving torrent data with DND files [TuxPaper]
BUGFIX: Core  | Fix NPE causing XML stats not to be written [Parg]
BUGFIX: UI    | Fix crash when opening non-torrent URL when OS has no recognized HTML viewer [TuxPaper]
BUGFIX: UI    | Fix big icon in name column for OSes using GTK [TuxPaper]
BUGFIX: UI    | Make Download Basket work again for drag and dropping [TuxPaper]
